#!/bin/bash

#Copyright (c) 2018-2019, The Linux Foundation. All rights reserved.

#Redistribution and use in source and binary forms, with or without
#modification, are permitted provided that the following conditions are
#met:
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
#    * Neither the name of The Linux Foundation nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.

#THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
#WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
#ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
#BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
#CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
#SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
#BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
#WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
#OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
#IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# process the .proto files
# use the file names and the directory names to create any lookup tables 
# that might be needed
set -e

# check command line arguments
if [ $# -lt 2 ]
then
    echo "Usage: $0 proto_dir output_dir"
    echo "WARNING: the output directories will be deleted if they already exist"
    exit 1	
else
    # capture the command line arguments
    PROTO_DIR=$1
    OUTPUT_DIR=$2
fi


# define our constants
GENERATED_MESSAGE="// This file was automatically generated by $0. DO NOT EDIT"

# this is the ADK Message definition
API_PROTO_FILE=messages.proto       # developers adds their message to this
API_PROTO_H_FILE=messages.pb.h      # generated by protoc
API_PROTO_CC_FILE=messages.pb.cc    # generated by protoc

# this file imports all the other proto files so the ADK message definition file
# can just include this single file
API_IMPORT_FILE=messages.import.proto       # generated by this script
API_IMPORT_H_FILE=messages.import.pb.h       # generated by protoc
API_IMPORT_CC_FILE=messages.import.pb.cc     # generator by protoc

# these are the helper header and source files. 
# They include child files to make building and including easier
API_H_FILE=messages.h                       # generated by this script
API_CC_FILE=messages.cc                     # generated by this script

# helper function to create a file which requires a copyright message
function create_file {
    echo "create $1"
    touch $1
#    cat $COPYRIGHT >> $1
    echo $GENERATED_MESSAGE >> $1
}

# custom code
custom_code_header="\n// helper code"
namespace_header=$(cat << EOF 
namespace adk {
namespace msg {
EOF
)

namespace_footer=$(cat << EOF
\n}  // namespace msg
}  // namespace adk
EOF
)

# table for converting an index to a pair of dbus strings
header_declarations=$(cat << EOF
\n// Structure to hold the ADK IPC D-Bus arguments: arg0 and arg1
struct dbus_args {
    std::string group;  // arg0
    std::string name;   // arg1
};

// lookup table to convert the oneof id to the dbus arguments
extern std::map<int, struct dbus_args> oneof_id_to_dbus_args;
extern std::map<std::string, AdkMessage::AdkMsgCase> msg_name_to_oneof_id;
EOF
)

# table for converting an index to a pair of dbus strings
dbus_table_header=$(cat << EOF
namespace adk {
namespace msg {
// lookup table to convert the oneof id to the dbus arguments
std::map<int, struct dbus_args> oneof_id_to_dbus_args = {
EOF
)

msg_name_table_header=$(cat << EOF
std::map<std::string, AdkMessage::AdkMsgCase> msg_name_to_oneof_id = {
EOF
)

#dbus_table_body=""

# printf format string for each line of the lookup table
dbus_table_row_format="  { AdkMessage::k%s, { .group = \"%s\", .name = \"%s\"} },"
msg_name_row_format="  {\"%s\", AdkMessage::k%s},"
# ========================
# ====== Main Script =====
# ========================
echo -e "\n=== Create target directory ==="
# create the target directories
# run the protobuf compiler for each directory
# move the files
# create the master header and source files
if [ -d $OUTPUT_DIR ]
then
	rm -r $OUTPUT_DIR
fi
mkdir -p $OUTPUT_DIR

OUTPUT_DIR_PYTHON=$OUTPUT_DIR"_python"
if [ -d $OUTPUT_DIR_PYTHON ]
then
	rm -r $OUTPUT_DIR_PYTHON
fi
mkdir -p $OUTPUT_DIR_PYTHON

echo -e "\n=== Discover the groups and messages ==="

# get a list of all the directories (group names) and .proto files
group_list=$(find $PROTO_DIR -maxdepth 2 \! -path "$PROTO_DIR/messages.proto" -iname "*.proto" | sed -re "s#$PROTO_DIR/([^/]+)(/.+|\.proto)#\1#" | sort -u)
proto_list=$(find $PROTO_DIR -maxdepth 2 \! -path "$PROTO_DIR/messages.proto" -iname "*.proto" -printf '%p ')
proto_list_no_parent=$(find $PROTO_DIR -maxdepth 2 \! -path "$PROTO_DIR/messages.proto" -iname "*.proto" -printf '%P ')

echo Groups found: $group_list
echo Proto files found: $proto_list

# create and populate the proto import file
# this file is used as redirection to import all the other .proto files
touch $OUTPUT_DIR/$API_IMPORT_FILE
echo 'syntax = "proto2";' >> $OUTPUT_DIR/$API_IMPORT_FILE
echo $GENERATED_MESSAGE >> $OUTPUT_DIR/$API_IMPORT_FILE
for each in $proto_list_no_parent
do
    echo 'import public "'$each'";' >> $OUTPUT_DIR/$API_IMPORT_FILE
done


# create and populate the proto import file for python
# this file is used as redirection to import all the other .proto files
touch $OUTPUT_DIR_PYTHON/$API_IMPORT_FILE
echo 'syntax = "proto2";' >> $OUTPUT_DIR_PYTHON/$API_IMPORT_FILE
echo $GENERATED_MESSAGE >> $OUTPUT_DIR_PYTHON/$API_IMPORT_FILE
for each in $proto_list_no_parent
do
    #result=${each/\//.}
    #echo 'import '$result'' >> $OUTPUT_DIR_PYTHON/$API_IMPORT_FILE
    echo 'import public "'$each'";' >> $OUTPUT_DIR_PYTHON/$API_IMPORT_FILE
done

echo -e "\n=== Compile the python proto files ==="
protoc --python_out $OUTPUT_DIR_PYTHON -I$PROTO_DIR -I$OUTPUT_DIR_PYTHON \
    $proto_list \
    $PROTO_DIR/$API_PROTO_FILE \
    $OUTPUT_DIR_PYTHON/$API_IMPORT_FILE


echo -e "\n=== Compile the C++ proto files ==="
protoc --cpp_out $OUTPUT_DIR -I$PROTO_DIR -I$OUTPUT_DIR \
    $proto_list \
    $PROTO_DIR/$API_PROTO_FILE \
    $OUTPUT_DIR/$API_IMPORT_FILE

find -name "*.pb.cc"
find -name "*.pb.h"

echo -e "\n=== Create the top level API .cc and .h files ==="

# create the top level group API files
create_file $OUTPUT_DIR/$API_H_FILE 
echo -e "\n#ifndef MESSAGES_MESSAGES_H" >> $OUTPUT_DIR/$API_H_FILE
echo -e "\n#define MESSAGES_MESSAGES_H" >> $OUTPUT_DIR/$API_H_FILE

echo -e "\n#include <iostream>" >> $OUTPUT_DIR/$API_H_FILE
echo -e "#include <map>" >> $OUTPUT_DIR/$API_H_FILE
create_file $OUTPUT_DIR/$API_CC_FILE

# add the main message and import proto file
# header files
echo -e "\n// Top level header files" >> $OUTPUT_DIR/$API_H_FILE
echo "#include \"$API_PROTO_H_FILE\"" >> $OUTPUT_DIR/$API_H_FILE
echo "#include \"$API_IMPORT_H_FILE\"" >> $OUTPUT_DIR/$API_H_FILE
echo -e "\n// Group header files" >> $OUTPUT_DIR/$API_H_FILE

# source files 
echo -e "\n// Top level source files" >> $OUTPUT_DIR/$API_CC_FILE
echo "#include \"$API_H_FILE\"" >> $OUTPUT_DIR/$API_CC_FILE
echo "#include \"$API_PROTO_CC_FILE\"" >> $OUTPUT_DIR/$API_CC_FILE
echo "#include \"$API_IMPORT_CC_FILE\"" >> $OUTPUT_DIR/$API_CC_FILE
echo -e "\n// Group source files" >> $OUTPUT_DIR/$API_CC_FILE

#
# Create the header and source #includes
# Loop through all the groups, add files to the API CC and H files
# create the lookup table
#
for group in $group_list
do
    echo -e "\nprocessing group: $group"
    
    # add the group to the top level API H and CC files
    echo -e "\n// Group: \"$group\" source files" >> $OUTPUT_DIR/$API_H_FILE
    echo -e "\n// Group: \"$group\" source files" >> $OUTPUT_DIR/$API_CC_FILE

    # add all the includes for the group to the top level API H and CC files
    find $OUTPUT_DIR -path "$OUTPUT_DIR/$group*.pb.h" -printf "#include \"%P\"\n" >> $OUTPUT_DIR/$API_H_FILE
    find $OUTPUT_DIR -path "$OUTPUT_DIR/$group*.pb.cc" -printf "#include \"%P\"\n" >> $OUTPUT_DIR/$API_CC_FILE

    # add to the lookup table
    pascal_case_group=$(echo $group | sed -re "s/(^|_)(.)/\U\2/g")
    proto_msg_list=$(grep -E "^\s*adk\.msg\.$group\..+" $PROTO_DIR/$API_PROTO_FILE | sed -re "s/[^_]+_([^ =]+).*/\1/")
    for msg_base_name in $proto_msg_list
    do
        pascal_case_name=$(echo $msg_base_name | sed -re "s/(^|_)(.)/\U\2/g")
        dbus_table_row="$(printf "$dbus_table_row_format" $pascal_case_group$pascal_case_name $group $msg_base_name)\n"
        dbus_table_body="$dbus_table_body$dbus_table_row"

        msg_name_table_row="$(printf "$msg_name_row_format" $pascal_case_group$pascal_case_name $pascal_case_group$pascal_case_name)\n"
        msg_name_table_body="$msg_name_table_body$msg_name_table_row"

    done

    # add to the group list
    group_table_row="const std::string kGroup$pascal_case_group = \"$group\";\n"
    group_table_body="$group_table_body$group_table_row"

done
dbus_table_body="$dbus_table_body};"
msg_name_table_body="$msg_name_table_body};"

dirs=($(find $OUTPUT_DIR_PYTHON -type d))
for dir in "${dirs[@]}"; do
    init_file=__init__.py    
    touch $dir/$init_file
done

# add the custom code to the header file
echo -e "$custom_code_header" >> $OUTPUT_DIR/$API_H_FILE
echo -e "$namespace_header" >> $OUTPUT_DIR/$API_H_FILE
echo -e "$header_declarations" >> $OUTPUT_DIR/$API_H_FILE
#echo -e "$dbus_table_body" >> $OUTPUT_DIR/$API_H_FILE

echo -e "$dbus_table_header" >> $OUTPUT_DIR/$API_CC_FILE
echo -e "$dbus_table_body" >> $OUTPUT_DIR/$API_CC_FILE

echo -e "$msg_name_table_header" >> $OUTPUT_DIR/$API_CC_FILE
echo -e "$msg_name_table_body" >> $OUTPUT_DIR/$API_CC_FILE

echo -e "\n// list of group names" >> $OUTPUT_DIR/$API_H_FILE
echo -e "$group_table_body" >> $OUTPUT_DIR/$API_H_FILE

echo -e "$namespace_footer" >> $OUTPUT_DIR/$API_H_FILE
echo -e "\n#endif  // MESSAGES_MESSAGES_H" >> $OUTPUT_DIR/$API_H_FILE
echo -e "$namespace_footer" >> $OUTPUT_DIR/$API_CC_FILE

#Generate HTML documentation
HTML_DOC="${OUTPUT_DIR}/../doc"
rm -rf $HTML_DOC
mkdir -p $HTML_DOC
echo -e "\n"

if [ -x "$(command -v protoc-gen-doc )" ]
then
    echo Found protoc-gen-doc in path
    for group in $group_list
    do
        echo -e "generating html document for: $group"
        html_output="$group.html"
        input=$(find $PROTO_DIR -path "$PROTO_DIR/$group*.proto" -printf "%p ")
        protoc --doc_out=$HTML_DOC --doc_opt=html,$html_output -I$PROTO_DIR $input
    done
    pushd "$HTML_DOC"
    tree -H "." -L 1 --noreport --charset utf-8 -P "*.html" > "index.html"
    popd
fi

exit 0


